clear
clc

% These numbers are only used to generate a valid range of Rn
Lr=80e-6;
Cr=340e-9;
n=10;
zvs=[Lr Cr n];
wr=1/sqrt(Lr*Cr);
Zr=sqrt(Lr/Cr);

Ro = logspace(log10(10),log10(10000),100);

Rn=Ro./n./n./Zr;
x_num = zeros(1, length(Ro));
syms x
for i=1:length(Rn)
    eqn = asin(1/sqrt(1+x))+sqrt(x)+pi/2 == 2*Rn(i)*x;
    solfs = vpasolve(eqn, x);
    xret = vpa(solfs);
    if (isempty(xret))
        x_num(i) = 0;
    else
        x_num(i) = abs(xret);
    end
    % There might be a tiny imaginary part due to numerical estimation
end

figure
semilogx(Rn, 0.25./Rn./x_num*2*pi);
title('Normalized frequency (w_n_o_m=w_r/w_s) vs Normalized Load Resistance');
xlabel('Normalized Load Resistance R_n(=R_L/n^2/Z_r)');
ylabel('Normalized Switching Frequency w_s');
set(gca,'YLim',[0 1]);

figure
semilogx(Rn, 2.*Rn.*(sqrt(x_num+1)-1));
title('Normalized Conversion Ratio (M=V_o/n/V_i_n) vs Normalized Load Resistance');
xlabel('Normalized Load Resistance R_n(=R_L/n^2/Z_r)');
ylabel('Normalized Conversion Ratio');
set(gca,'YLim',[1 1.6]);